<template>
  <div>
    {{type}}: {{amount}} ({{otherAddress}})
  </div>
</template>
<script>

import { get } from '~/lib/utils';
import BN from 'bignumber.js';

function intersection(a,b) {
  const r = []
  for(var v of a) {
    if(b.includes(v)) r.push(v);
    return r;
  }
}

export default {
  props: ['value','currency'],
  data() {
    return {
      type: null,
      otherAddress: null,
      amount: null,
    };
  },
  created() {
    this.categorize();
  },
  watch: {
    value() { this.categorize() },
    currency() { this.categorize() },
  },
  methods: {
    categorize() {
      const transfers = get(this.value,'_embedded.transfers');
      const fromAddresses = [];
      const toAddresses = [];
      
      for(let transfer of transfers) {
        const { from_address: from, to_address: to } = transfer;
        if(from && from != 'unknown') {
          fromAddresses.push(from);
        }
        if(to && to != 'unknown') {
          toAddresses.push(to);
        }
      }
      
      const ourFromAddresses = intersection(fromAddresses,this.currency.watchedAddresses);
      const receiveAddresses = this.currency.receiveAddresses.concat(this.currency.alternateReceiveAddresses||[]);
      const ourToAddresses = intersection(toAddresses,receiveAddresses);

      if(ourFromAddresses.length > 0 && ourToAddresses.length > 0) {
        this.type = 'internal';

        const internal = transfers.filter(t => receiveAddresses.includes(t.to_address));
        // debugger;
        
        this.amount = internal.map(t => get(t,'amount.amount')).reduce((a,b) => BN(a).plus(b),new BN(0));
        this.otherAddress = internal.map(t => get(t,'to_address')).join(', ');
      } else if(ourFromAddresses.length > 0) {
        // we're sending out funds - this is a send:
        this.type = 'send';
        
        const outbound = transfers.filter(t => t.to_address != 'unknown' && !this.currency.watchedAddresses.includes(t.to_address));
        
        this.amount = outbound.map(t => get(t,'amount.amount')).reduce((a,b) => Number(a)+Number(b),0);
        this.otherAddress = outbound.map(t => get(t,'to_address')).join(', ');
      } else {
        // we're receiving funds:
        this.type = 'receive';
        
        const inbound = transfers.filter(t => t.to_address != 'unknown' && this.currency.watchedAddresses.includes(t.to_address));
        
        this.amount = inbound.map(t => get(t,'amount.amount')).reduce((a,b) => Number(a)+Number(b),0);
        this.otherAddress = transfers.filter(t => t.from_address != 'unknown').map(t => get(t,'from_address')).join(', ');
      }
    }
  }
}
  
</script>
